> ## Documentation Index
> Fetch the complete documentation index at: https://docs.contentignite.com/llms.txt
> Use this file to discover all available pages before exploring further.

# /report/insight/demand-mix

> Returns data for all revenue source combinations, including (publisher, Content Ignite) and (direct, programmatic, fallback)



## OpenAPI

````yaml /openapi.json get /v1/report/insight/demand-mix
openapi: 3.0.1
info:
  title: CI Public API
  description: >-
    # Introduction

    Welcome to the Content Ignite API. A central place for all Content Ignite
    functionality. 


    This API enforces a separation between function and form, meaning anything
    you can do in our platforms can be replicated in your own bespoke solution.


    # Authentication

    Authentication is handled via JWTs. You can retrieve your unique JSON Web
    Token from the settings page in the platform, which needs to be passed in
    with every request.

    To do this, simple include it in an Authorization header with the "Bearer"
    key word.


    Please contact support for help getting started.


    # Error Codes

    This is a fully RESTful API, so prepare for a number of different HTTP
    status codes.


    There is also a standard "success" field returned for each request. This
    boolean value can provide a first check against a response.


    # Rate limit

    We reserve the right to block requests if we deem a client to be abusing the
    API.
  version: 1.0.0
servers:
  - url: https://api.tagdeliver.com
    description: Production
security:
  - BearerAuth: []
tags:
  - name: Reporting
  - name: Reporting/Revenue Reports
  - name: Reporting/Experiment Reporting
  - name: Reporting/Campaign Reports
  - name: Reporting/Health Check
  - name: Reporting/Ads.txt
  - name: Reporting/Utility
  - name: Reporting/Insights Hub
  - name: Reporting/Insights Hub/SSP Insights
  - name: Reporting/Insights Hub/Core Web Vitals
  - name: Reporting/Insights Hub/Ads.txt Insights
  - name: Reporting/Insights Hub/Live Insights
  - name: Reporting/Insights Hub/Metrics
  - name: Reporting/Insights Hub/Diagnostics
  - name: Reporting/Insights Hub/Revenue Insights
  - name: Reporting/Insights Hub/Revenue Analytics
  - name: Reporting/Insights Hub/Demand Mix
  - name: Reporting/Insights Hub/Benchmarking
  - name: Organisation
  - name: Organisation/Organisation Meta
  - name: Organisation/Pricing
  - name: Ad Stack
  - name: Ad Stack/Integration
  - name: Publisher
  - name: Publisher/Publisher Stack
  - name: Publisher/Publisher Tag
  - name: Publisher/Publisher Meta
  - name: Publisher/Experiment
  - name: Publisher/Config (Ad unit)
  - name: Publisher/App Placement
  - name: Billing
  - name: Billing/Invoice
  - name: '[IN PROGRESS] Integration'
  - name: '[TODO] User'
  - name: '[TODO] User/Account'
  - name: public
paths:
  /v1/report/insight/demand-mix:
    get:
      tags:
        - Reporting/Insights Hub/Demand Mix
        - public
      summary: /report/insight/demand-mix
      description: >-
        Returns data for all revenue source combinations, including (publisher,
        Content Ignite) and (direct, programmatic, fallback)
      parameters:
        - name: uid
          in: query
          description: Publisher ID
          required: false
          schema:
            type: integer
        - name: range
          in: query
          description: Date range. All ranges exclude today and run up to yesterday
          required: false
          schema:
            type: string
            enum:
              - custom
              - all_time
              - seven_days
              - fourteen_days
              - thirty_days
              - three_months
              - six_months
              - week_to_date
              - month_to_date
              - quarter_to_date
              - year_to_date
              - last_week
              - last_month
              - last_quarter
              - last_year
              - month_on_month
              - quarter_on_quarter
              - yesterday
        - name: start
          in: query
          description: Start date when range=custom
          required: false
          schema:
            type: string
            format: date
        - name: end
          in: query
          description: End date when range=custom
          required: false
          schema:
            type: string
            format: date
        - name: date_group
          in: query
          description: Date grouping when range=custom
          required: false
          schema:
            type: string
            enum:
              - day
              - month
              - year
            default: day
        - name: rev_type
          in: query
          description: Revenue type
          required: false
          schema:
            type: string
            enum:
              - gross
              - net
            default: gross
        - name: rev_source
          in: query
          description: Revenue source, SaaS or Plug&Play (pap)
          required: false
          schema:
            type: string
            enum:
              - all
              - pap
              - saas
            default: all
        - name: environment
          in: query
          description: Environment or platform to report from
          required: false
          schema:
            type: string
            enum:
              - all
              - app
              - web
            default: all
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                type: object
                properties:
                  results:
                    type: object
                    properties:
                      currency:
                        type: string
                      dates:
                        type: array
                        items:
                          type: string
                      data:
                        type: object
                        properties:
                          revenue:
                            type: object
                            properties:
                              total:
                                type: array
                                items:
                                  type: number
                                  nullable: true
                              direct:
                                type: array
                                items:
                                  type: number
                                  nullable: true
                              programmatic:
                                type: array
                                items:
                                  type: number
                                  nullable: true
                              fallback:
                                type: array
                                items:
                                  type: integer
                                  nullable: true
                              untracked:
                                type: array
                                items:
                                  type: number
                                  nullable: true
                              ci_direct:
                                type: array
                                items:
                                  type: integer
                                  nullable: true
                              ci_programmatic:
                                type: array
                                items:
                                  type: number
                                  nullable: true
                              ci_fallback:
                                type: array
                                items:
                                  type: number
                                  nullable: true
                              ci_untracked:
                                type: array
                                items:
                                  type: number
                                  nullable: true
                              publisher_direct:
                                type: array
                                items:
                                  type: number
                                  nullable: true
                              publisher_programmatic:
                                type: array
                                items:
                                  type: number
                                  nullable: true
                              publisher_fallback:
                                type: array
                                items:
                                  type: integer
                                  nullable: true
                              publisher_untracked:
                                type: array
                                items:
                                  type: number
                            required:
                              - total
                              - direct
                              - programmatic
                              - fallback
                              - untracked
                              - ci_direct
                              - ci_programmatic
                              - ci_fallback
                              - ci_untracked
                              - publisher_direct
                              - publisher_programmatic
                              - publisher_fallback
                              - publisher_untracked
                          impressions:
                            type: object
                            properties:
                              total:
                                type: array
                                items:
                                  type: integer
                              direct:
                                type: array
                                items:
                                  type: integer
                              programmatic:
                                type: array
                                items:
                                  type: integer
                              fallback:
                                type: array
                                items:
                                  type: integer
                              untracked:
                                type: array
                                items:
                                  type: integer
                              ci_direct:
                                type: array
                                items:
                                  type: integer
                              ci_programmatic:
                                type: array
                                items:
                                  type: integer
                              ci_fallback:
                                type: array
                                items:
                                  type: integer
                                  nullable: true
                              ci_untracked:
                                type: array
                                items:
                                  type: integer
                                  nullable: true
                              publisher_direct:
                                type: array
                                items:
                                  type: integer
                              publisher_programmatic:
                                type: array
                                items:
                                  type: integer
                              publisher_fallback:
                                type: array
                                items:
                                  type: integer
                              publisher_untracked:
                                type: array
                                items:
                                  type: integer
                            required:
                              - total
                              - direct
                              - programmatic
                              - fallback
                              - untracked
                              - ci_direct
                              - ci_programmatic
                              - ci_fallback
                              - ci_untracked
                              - publisher_direct
                              - publisher_programmatic
                              - publisher_fallback
                              - publisher_untracked
                          viewable_impressions:
                            type: object
                            properties:
                              total:
                                type: array
                                items:
                                  type: integer
                              direct:
                                type: array
                                items:
                                  type: integer
                              programmatic:
                                type: array
                                items:
                                  type: integer
                              fallback:
                                type: array
                                items:
                                  type: integer
                              untracked:
                                type: array
                                items:
                                  type: integer
                              ci_direct:
                                type: array
                                items:
                                  type: integer
                              ci_programmatic:
                                type: array
                                items:
                                  type: integer
                              ci_fallback:
                                type: array
                                items:
                                  type: integer
                                  nullable: true
                              ci_untracked:
                                type: array
                                items:
                                  type: integer
                                  nullable: true
                              publisher_direct:
                                type: array
                                items:
                                  type: integer
                              publisher_programmatic:
                                type: array
                                items:
                                  type: integer
                              publisher_fallback:
                                type: array
                                items:
                                  type: integer
                              publisher_untracked:
                                type: array
                                items:
                                  type: integer
                            required:
                              - total
                              - direct
                              - programmatic
                              - fallback
                              - untracked
                              - ci_direct
                              - ci_programmatic
                              - ci_fallback
                              - ci_untracked
                              - publisher_direct
                              - publisher_programmatic
                              - publisher_fallback
                              - publisher_untracked
                          ad_requests:
                            type: object
                            properties:
                              total:
                                type: array
                                items:
                                  type: integer
                            required:
                              - total
                        required:
                          - revenue
                          - impressions
                          - viewable_impressions
                          - ad_requests
                      stats:
                        type: object
                        properties:
                          total:
                            type: number
                          publisher:
                            type: number
                          ci:
                            type: number
                          publisher_direct:
                            type: number
                          publisher_programmatic:
                            type: number
                          publisher_fallback:
                            type: integer
                          publisher_untracked:
                            type: number
                          ci_direct:
                            type: integer
                          ci_programmatic:
                            type: number
                          ci_fallback:
                            type: integer
                          ci_untracked:
                            type: integer
                        required:
                          - total
                          - publisher
                          - ci
                          - publisher_direct
                          - publisher_programmatic
                          - publisher_fallback
                          - publisher_untracked
                          - ci_direct
                          - ci_programmatic
                          - ci_fallback
                          - ci_untracked
                    required:
                      - currency
                      - dates
                      - data
                      - stats
                  success:
                    type: boolean
                required:
                  - results
                  - success
              example:
                results:
                  currency: GBP
                  dates:
                    - '2025-11-24'
                  data:
                    revenue:
                      total:
                        - 6339.721715000006
                      direct:
                        - 6090.406587000007
                      programmatic:
                        - 230.87629800000002
                      fallback:
                        - 0
                      untracked:
                        - 18.43883
                      ci_direct:
                        - 0
                      ci_programmatic:
                        - 22.155095
                      ci_fallback:
                        - null
                      ci_untracked:
                        - null
                      publisher_direct:
                        - 6090.406587000007
                      publisher_programmatic:
                        - 208.72120300000003
                      publisher_fallback:
                        - 0
                      publisher_untracked:
                        - 18.43883
                    impressions:
                      total:
                        - 656967
                      direct:
                        - 346071
                      programmatic:
                        - 170875
                      fallback:
                        - 131445
                      untracked:
                        - 8576
                      ci_direct:
                        - 8653
                      ci_programmatic:
                        - 31610
                      ci_fallback:
                        - null
                      ci_untracked:
                        - null
                      publisher_direct:
                        - 337418
                      publisher_programmatic:
                        - 139265
                      publisher_fallback:
                        - 131445
                      publisher_untracked:
                        - 8576
                    viewable_impressions:
                      total:
                        - 268921
                      direct:
                        - 119191
                      programmatic:
                        - 101411
                      fallback:
                        - 47494
                      untracked:
                        - 825
                      ci_direct:
                        - 5151
                      ci_programmatic:
                        - 14631
                      ci_fallback:
                        - null
                      ci_untracked:
                        - null
                      publisher_direct:
                        - 114040
                      publisher_programmatic:
                        - 86780
                      publisher_fallback:
                        - 47494
                      publisher_untracked:
                        - 825
                    ad_requests:
                      total:
                        - 1227014
                  stats:
                    total: 6339.721715000006
                    publisher: 6317.566620000007
                    ci: 22.155095
                    publisher_direct: 6090.406587000007
                    publisher_programmatic: 208.72120300000003
                    publisher_fallback: 0
                    publisher_untracked: 18.43883
                    ci_direct: 0
                    ci_programmatic: 22.155095
                    ci_fallback: 0
                    ci_untracked: 0
                success: true
          headers: {}
      deprecated: false
      security:
        - BearerAuth: []
components:
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer

````